=== doomsday/tests/test_bitfield/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)
project (DENG_TEST_BITFIELD)
include (../TestConfig.cmake)

deng_test (test_bitfield main.cpp)
