=== debian/changelog ===
doomsday (2.2.2+ds1-1~exp2) experimental; urgency=medium

  * Team upload.
  * debian/control:
    + Replace build-dependency of libqt5opengl5-dev with
      libqt5opengl5-desktop-dev. This game is know to be requiring
      desktop OpenGL support. (Previously explicitly excluded armel
      and armhf in the architecture section)
    + Use "Rules-Require-Root: no".
    + Mark package doomsday-data as Multi-Arch: foreign.
  * debian/copyright: Fix file matching issues (lintian info).
  * debian/doomsday.links: Dropped for now since we are not shipping
    doomsday-compat script.

 -- Boyuan Yang <byang@debian.org>  Fri, 14 Feb 2020 23:00:03 -0500

doomsday (2.2.2+ds1-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release. (Closes: #884608)
    + WARNING: This release (2.2.2+ds1-1~exp1) is an experimental Debian
      package that may break. USE IT AT YOUR OWN RISK!
      If you found any bug with packaged doomsday 2.x, please report it!
    + TODO: Strip out fonts in Files-Exluded list.
    + TODO: Incorporate with the alternatives system.
    + TODO: Move the executables back to /usr/games/.
    + Migrated to Qt5. (Closes: #874870)
    + Migrated to Python3. (Closes: #936437)
  * debian/control:
    + Bump debhelper compat to v12.
    + Bump Standards-Version to 4.5.0.
    + Update build-dependencies and switch to a CMake-based buildsystem.
    + Update Vcs-* fields to use git packaging repo under Salsa games-team.
    + Update homepage field to use secure URI.
  * debian/patches-old: Moved away for a patch-free version.
  * debian/patches:
    + 0001: Add new patch to disable RPATH completely.
    + 0002: Add new patch to let .desktop files use /usr/games/ path.
  * debian/doomsday.install:
    + Do not install a compat script.
  * debian/doomsday-server.install: Install the doomsday-shell and
    doomsday-shell-text binaries. (Closes: #864250)
  * debian/doomsday.desktop: Dropped in favor of upstream desktop file.
  * debian/doomsday.menu: Dropped per tech-ctte's decision.
  * debian/doomsday.xpm: Dropped in favor of upstream-provided icon.
  * debian/upstream/metadata: Add information about Repository and
    Repository-Browse.
  * debian/clean: Also clean doomsday/apps/api/dd_version.h.
  * debian/doomsday.manpages: Update man page installation path.

 -- Boyuan Yang <byang@debian.org>  Fri, 14 Feb 2020 17:39:12 -0500
