=== doomsday/tests/test_record/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)
project (DENG_TEST_RECORD)
include (../TestConfig.cmake)

deng_test (test_record main.cpp)
