=== debian/changelog ===
doomsday (2.3.1+ds1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Workaround FTBFS with CMake 4. (Closes: #1112854)
  * Add workaround from Bernhard Übelacker for running
    under Wayland. (Closes: #1113738)

 -- Adrian Bunk <bunk@debian.org>  Thu, 30 Oct 2025 19:32:32 +0200

doomsday (2.3.1+ds1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump Standards-Version to 4.6.0.
  * debian/*.lintian-overrides: Remove unknown tag
    no-upstream-changelog.

 -- Boyuan Yang <byang@debian.org>  Tue, 07 Sep 2021 17:23:34 -0400

doomsday (2.2.2+ds1-1) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * debian/doomsday-compat: Add back the compatibility layer.
  * debian/patches-old: Drop no-libexample.patch, no longer
    needed.
  * debian/control: Update Vcs-* field to use correct one.

 -- Boyuan Yang <byang@debian.org>  Mon, 02 Mar 2020 15:54:49 -0500
