## doomsday 2.3.1+ds1

=== CMakeLists.txt ===
# Doomsday Engine
# Top-level CMakeLists

cmake_minimum_required (VERSION 3.1)
project (Doomsday)
add_subdirectory (doomsday)
