=== doomsday/tests/test_commandline/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)
project (DENG_TEST_COMMANDLINE)
include (../TestConfig.cmake)

deng_test (test_commandline main.cpp)
