=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Michael Gilbert <mgilbert@debian.org>
 Build-Depends:
  cmake,
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  python3:any,
  qtbase5-dev,
  zlib1g-dev,
@@ -21,11 +21,11 @@
  libgl1-mesa-dev | libgl-dev,
  libglu1-mesa-dev | libglu-dev,
  libminizip-dev,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://www.dengine.net
-Vcs-Git: https://salsa.debian.org/games-team/doomsday.git
-Vcs-Browser: https://salsa.debian.org/games-team/doomsday
+Vcs-Git: https://salsa.debian.org/games-team/deng.git
+Vcs-Browser: https://salsa.debian.org/games-team/deng
 
 Package: doomsday
 Architecture: any
