=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

export DEB_LDFLAGS_MAINT_APPEND=

export QT_SELECT := 5

# For SOURCE_DATE_EPOCH and DEB_VERSION
include /usr/share/dpkg/default.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	        -DDENG_ASSIMP_EMBEDDED:BOOL=OFF \
	        -DDENG_BUILD=$(DEB_VERSION) \
	        -DCMAKE_INSTALL_BINDIR=games \
	        -DCMAKE_POLICY_VERSION_MINIMUM=3.5
