=== debian/watch ===
version=4
opts="repack,compression=xz,repacksuffix=+ds1,dversionmangle=auto" \
 https://files.dengine.net/archive/ doomsday-([\d.]+)@ARCHIVE_EXT@ debian uupdate
